searchNodes=[{"doc":"Control GPIOs using the GPIO chip interface With the character device driver for GPIOs there three concepts to learn. First, the API is made up of chips and lines that are grouped together for that chip. A chip is more of a grouping identifier than anything physical property about the board. Secondly, the API requires us to request lines from a GPIO chip. The reason for this is the kernel can provide control over who &quot;owns&quot; that line and prevent multiple programs from trying to control the same GPIO pin. Lastly, you can listen for events on a line. These events report if the line is high or low. Generally speaking the character device driver allows more fine grain control and more reliability than the sysfs API.","ref":"Circuits.GPIO.Chip.html","title":"Circuits.GPIO.Chip","type":"module"},{"doc":"Getting information about a line","ref":"Circuits.GPIO.Chip.html#get_line_info/2","title":"Circuits.GPIO.Chip.get_line_info/2","type":"function"},{"doc":"Listen to line events on the line offset Circuits.GPIO.Chip . listen_event ( mygpio_chip , 24 ) # cause the offset to change value flush { :circuits_cdev , 24 , timestamp , new_value } The timestamp will be in nanoseconds so as you do time calculations and conversions be sure to take that into account. The new_value will be the value the offset value changed to either 1 or 0 .","ref":"Circuits.GPIO.Chip.html#listen_event/2","title":"Circuits.GPIO.Chip.listen_event/2","type":"function"},{"doc":"Open a GPIO Chip { :ok , chip } = Circuits.GPIO.Chip . open ( gpiochip_device )","ref":"Circuits.GPIO.Chip.html#open/1","title":"Circuits.GPIO.Chip.open/1","type":"function"},{"doc":"Read value from a line handle This is useful when you have a line handle that contains only one GPIO offset. If you want to read multiple GPIOs at once see Circuits.GPIO.Chip.read_values/1 . { :ok , line_handle } = Circuits.GPIO.Chip . request_line ( &quot;gpiochip0&quot; , 17 ) { :ok , 0 } = Circuits.GPIO.Chip . read_value ( line_handle )","ref":"Circuits.GPIO.Chip.html#read_value/1","title":"Circuits.GPIO.Chip.read_value/1","type":"function"},{"doc":"Read values for a line handle This is useful when you a line handle that contains multiple GPIO offsets. { :ok , line_handle } = Circuits.GPIO.Chip . request_lines ( &quot;gpiochip0&quot; , [ 17 , 22 , 23 , 24 ] ) { :ok , [ 0 , 0 , 0 , 0 ] } = Circuits.GPIO.Chip . read_values ( line_handle ) Note that the values in the list match the index order of how the offsets were requested. Note that the order of the values returned return the order that the offsets were requested.","ref":"Circuits.GPIO.Chip.html#read_values/1","title":"Circuits.GPIO.Chip.read_values/1","type":"function"},{"doc":"Request a line handle for a single GPIO offset { :ok , line_handle } = Circuits.GPIO.Chip . request_line ( my_gpio_chip , 17 , :output ) See Circuits.GPIO.Chip.request_lines/3 and Circuits.GPIO.LineHandle for more details about line handles.","ref":"Circuits.GPIO.Chip.html#request_line/3","title":"Circuits.GPIO.Chip.request_line/3","type":"function"},{"doc":"Request a line handle for multiple GPIO offsets { :ok , line_handle } = Circuits.GPIO.Chip . request_lines ( my_gpio_chip , [ 17 , 24 ] , :output ) For the GPIO character device driver you drive GPIOs by requesting for a line handle what contains one or more GPIO offsets. The line handle is mechanism by which you can read and set the values of the GPIO(s). The line handle is attached to the calling process and kernel will not allow others to control the GPIO(s) that are part of that the line handle. Moreover, one the process that requested the line handle goes away the kernel will be able to automatically free the system resources that were tied to that line handle.","ref":"Circuits.GPIO.Chip.html#request_lines/3","title":"Circuits.GPIO.Chip.request_lines/3","type":"function"},{"doc":"Set the value of the GPIO { :ok , line_handle } = Circuits.GPIO.Chip . request_lines ( my_gpio_chip , 17 ) { :ok , 0 } = Circuits.GPIO.Chip . read_value ( line_handle ) :ok = Circuits.GPIO.Chip . set_value ( line_handle , 1 ) { :ok , 1 } = Circuits.GPIO.Chip . read_value ( line_handle )","ref":"Circuits.GPIO.Chip.html#set_value/2","title":"Circuits.GPIO.Chip.set_value/2","type":"function"},{"doc":"Set values of the GPIOs { :ok , line_handle } = Circuits.GPIO.Chip . request_lines ( my_gpio_chip , [ 17 , 24 , 22 ] ) { :ok , [ 0 , 0 , 0 ] } = Circuits.GPIO.Chip . read_value ( line_handle ) :ok = Circuits.GPIO.Chip . set_value ( line_handle , [ 1 , 0 , 1 ] ) { :ok , [ 1 , 0 , 1 ] } = Circuits.GPIO.Chip . read_value ( line_handle ) Note that the order of the values that were sent matches the order by which the GPIO offsets where requested. In the example above offset 17 was set to 1, offset 24 was stayed at 0, offset 22 was set to 1.","ref":"Circuits.GPIO.Chip.html#set_values/2","title":"Circuits.GPIO.Chip.set_values/2","type":"function"},{"doc":"The direction of the line With the character device you drive a line with configured offsets. These offsets all share a direction, either :output or :input , which is called the line direction. The :output direction means you control the GPIOs by setting the value of the GPIOs to 1 or 0. See Circuits.GPIO.Chip.set_value/2 for more information. The :input direction means you can only read the current value of the GPIOs on the line. See Circuits.GPIO.Chip.read_value/1 for more information.","ref":"Circuits.GPIO.Chip.html#t:line_direction/0","title":"Circuits.GPIO.Chip.line_direction/0","type":"type"},{"doc":"The offset of the pin An offset is the pin number provided. Normally these are labeled GPIO N or GPIO_N where N is the pin number. For example, if you wanted to use to use GPIO 17 on a Raspberry PI the offset value would be 17 . More resources: Raspberry PI: https://pinout.xyz/ Beaglebone: https://beagleboard.org/Support/bone101","ref":"Circuits.GPIO.Chip.html#t:offset/0","title":"Circuits.GPIO.Chip.offset/0","type":"type"},{"doc":"The value of the offset This is either 0 for low or off, or 1 for high or on.","ref":"Circuits.GPIO.Chip.html#t:offset_value/0","title":"Circuits.GPIO.Chip.offset_value/0","type":"type"},{"doc":"","ref":"Circuits.GPIO.Chip.html#t:t/0","title":"Circuits.GPIO.Chip.t/0","type":"type"},{"doc":"A handle to read and set values to GPIO line(s)","ref":"Circuits.GPIO.Chip.LineHandle.html","title":"Circuits.GPIO.Chip.LineHandle","type":"module"},{"doc":"","ref":"Circuits.GPIO.Chip.LineHandle.html#t:t/0","title":"Circuits.GPIO.Chip.LineHandle.t/0","type":"type"},{"doc":"Line information","ref":"Circuits.GPIO.Chip.LineInfo.html","title":"Circuits.GPIO.Chip.LineInfo","type":"module"},{"doc":"","ref":"Circuits.GPIO.Chip.LineInfo.html#t:t/0","title":"Circuits.GPIO.Chip.LineInfo.t/0","type":"type"},{"doc":"circuits_cdev Character device GPIO library for Elixir. Since Linux 4.8 the sysfs interface is deprecated in preference of the character device GPIO API. The advantages of the character device API over the sysfs interface are: The allocation of the GPIO is tied to the process that is using it, which prevents many process from trying to control a GPIO at once. Since the GPIO is tied to the process, if the process ends for any reason the GPIO will be cleaned up automatically. It is possible to read or write many GPIOs at once. It is possible to configure the state of the GPIO (open-source, open-drain, etc). The polling process to catch event is reliable. The way to drive a GPIO line (a pin) is by requesting a line handle from a GPIO chip. A system may have many GPIO chips and these can be named or they default to using the name gpiochipN where N is the chip number starting a 0 . For example the main GPIO chip on the Raspberry PI systems is gpiochip0 located at &quot;/dev/gpiochip0&quot; .","ref":"readme.html","title":"circuits_cdev","type":"extras"},{"doc":"def deps do [ { :circuits_cdev , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#install","title":"circuits_cdev - Install","type":"extras"},{"doc":"First request a line handle from the GPIO chip: { :ok , line_handle } = Circuits.GPIO.Chip . request_line ( &quot;gpiochip0&quot; , 17 , :output ) After getting a line handle can now set the value of the line: Circuits.GPIO.Chip . read_value ( line_handle ) 0 To set the value of the line: Circuits.GPIO.Chip . set_value ( line_handle , 1 ) :ok","ref":"readme.html#controlling-the-output-of-a-line","title":"circuits_cdev - Controlling the output of a line","type":"extras"},{"doc":"First request a line handle from the GPIO chip: { :ok , line_handle } = Circuits.GPIO.Chip . request_line ( &quot;gpiochip0&quot; , [ 17 , 27 20 ] , :output ) After getting the line handle you can set the values of the lines. Notice that you to provide all the values in the same order as you requested the lines: Circuits.GPIO.Chip . set_values ( line_handle , [ 0 , 1 , 1 ] ) When reading the values of a line handle that controls more than one line you will receive a list of values in the order of that you requested the lines: Circuits.GPIO.Chip . read_values ( line_handle ) { :ok , [ 0 , 1 , 1 ] }","ref":"readme.html#controlling-the-output-of-many-lines","title":"circuits_cdev - Controlling the output of many lines","type":"extras"},{"doc":"You can listen for events on an GPIO line by calling the listen_event/2 function: Circuits.GPIO.Chip . listen_event ( &quot;gpiochip0&quot; , 27 ) :ok When an event is received from the line it will be in the form of: { :circuits_cdev , pin_number , timestamp , new_value } The timestamp is the unix time in nanoseconds. In order to convert it into a DateTime you will need to pass the :nanoseconds as the unit to DateTime.from_unix/3 function: DateTime . from_unix ( timestamp , :nanoseconds ) { :ok , ~U[1990-07-24 07:30:03.123456Z] } Also when calculating the time delta between two events keep in mind the difference will be nanoseconds.","ref":"readme.html#listen-for-events-on-a-line","title":"circuits_cdev - Listen for events on a line","type":"extras"}]